﻿--[[
Aero:RegisterFrames(...)
Use it to register show/hide animation to frames
Arguments can be either frame names or hook functions, seperated by commas
]]

Aero:RegisterFrames(
	"GameMenuFrame",
	"AudioOptionsFrame",
	"VideoOptionsFrame",
	"InterfaceOptionsFrame",
	"OpacityFrame",
	"ItemRefTooltip",
	"OpenMailFrame",
	"StackSplitFrame",
	"ColorPickerFrame",
	"GuildInfoFrame",
	"PVPTeamDetails",
	"ChatConfigFrame",
	"GearManagerDialog",
	"ReputationDetailFrame",
	"PVPParentFrame",
	"LootFrame",
	"HelpFrame",
	"MailFrame",
	"ArenaFrame",
	"TradeFrame",
	"GossipFrame",
	"TabardFrame",
	"FriendsFrame",
	"MerchantFrame",
	"QuestLogFrame",
	"SpellBookFrame",
	"PetStableFrame",
	"BattlefieldFrame",
	"GuildRegistrarFrame",
	"ArenaRegistrarFrame",
	"LFDParentFrame",
	"CharacterFrame"
)

--[[
Aero:RegisterAddon(addon, ...)
Use it to register frames that are created after addon loaded or on demand
Arguments:
	addon - addon's name
	... - either frame names or hook functions, seperated by commas
]]

Aero:RegisterAddon("Blizzard_CraftUI", "CraftFrame")
Aero:RegisterAddon("Blizzard_MacroUI", "MacroFrame")
Aero:RegisterAddon("Blizzard_AuctionUI", "AuctionFrame", "AuctionDressUpFrame")
Aero:RegisterAddon("Blizzard_GuildBankUI", "GuildBankFrame")
Aero:RegisterAddon("Blizzard_TalentUI", "PlayerTalentFrame")
Aero:RegisterAddon("Blizzard_TradeSkillUI", "TradeSkillFrame")
Aero:RegisterAddon("Blizzard_TrainerUI", "ClassTrainerFrame")
Aero:RegisterAddon("Blizzard_GMSurveyUI", "GMSurveyFrame")
Aero:RegisterAddon("Blizzard_AchievementUI", "AchievementFrame")
Aero:RegisterAddon("Blizzard_BattlefieldMinimap", "BattlefieldMinimap")
Aero:RegisterAddon("Blizzard_ItemSocketingUI", "ItemSocketingFrame")
Aero:RegisterAddon("ALZAUI", "aBagsHolder", "aBagsBankHolder")

Aero:RegisterAddon("cargBags", function()
	hooksecurefunc(cargBags, "Spawn", function(_, name)
		Aero:RegisterFrames(name)
	end)
end)